local AddOn, _DUF = ...
local strfind = string.find

local classesIcons = {
			["WARRIOR"] = { .25, 0, 0, .25 },
			["MAGE"] = { .5, .25, 0, .25 },
			["ROGUE"] = { .75, .5, 0, .25 },
			["DRUID"] = { 1, .75, 0, .25 },
			["HUNTER"] = { .25, 0, .25, .5 },
			["SHAMAN"] = { .5, .25, .25, .5 },
			["PRIEST"] = { .75, .5, .25, .5 },
			["WARLOCK"] = { 1, .75, .25, .5 },
			["PALADIN"] = { .25, 0, .5, .75 },
			["DEATHKNIGHT"] = { .5, .25, .5, .75 },
			["MONK"] = { .75, .5, .5, .75 },
			["DEMONHUNTER"] = { 1, .75, .5, .75 },
		}

function _DUF:DUF_Set_ClassIcon(unit)
--	local class = UnitClass(unit);
	local texture = _G[DUF_FRAME_DATA[unit].frame.."_ClassIcon"].Icon
--	local left, right, top, bottom
	local class, file = UnitClass(unit);
	if not file then return end
	local left, right, top, bottom = unpack(classesIcons[file])
--[[ Legion
	if (class == DUF_TEXT.Warrior) then
		left, right, top, bottom = .25, 0, 0, .25;
	elseif (class == DUF_TEXT.Mage) then
		left, right, top, bottom = .5, .25, 0, .25;
	elseif (class == DUF_TEXT.Rogue) then
		left, right, top, bottom = .75, .5, 0, .25;
	elseif (class == DUF_TEXT.Druid) then
		left, right, top, bottom = 1, .75, 0, .25;
	elseif (class == DUF_TEXT.Hunter) then
		left, right, top, bottom = .25, 0, .25, .5;
	elseif (class == DUF_TEXT.Shaman) then
		left, right, top, bottom = .5, .25, .25, .5;
	elseif (class == DUF_TEXT.Priest) then
		left, right, top, bottom = .75, .5, .25, .5;
	elseif (class == DUF_TEXT.Warlock) then
		left, right, top, bottom = 1, .75, .25, .5;
	elseif (class == DUF_TEXT.Paladin) then
		left, right, top, bottom = .25, 0, .5, .75;
	elseif (class == DUF_TEXT.DeathKnight) then
		left, right, top, bottom = .5, .25, .5, .75;
	elseif (class == DUF_TEXT.Monk) then
		left, right, top, bottom = .75, .5, .5, .75;
	end
]]--
	if (class) then
		texture:SetTexCoord(right, left, top, bottom);	
	else
		texture:SetTexCoord(0, .25, 0, .25);
	end
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].ClassIcon.userace) then
		if (UnitIsPlayer(unit)) then
			texture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes");
		else
			_DUF:DUF_Set_RaceIcon(unit, 1, texture);
		end
	end
end

function _DUF:DUF_Set_ElementPosition(frame, unitFrame, settings)
	local attachframe = unitFrame..settings.attach;
	if (settings.attach == "Unit Frame") then
		attachframe = unitFrame;
	elseif (settings.attach == "UIParent") then
		attachframe = "UIParent";
	end
	frame:ClearAllPoints();
	frame:SetPoint(settings.attachpoint, attachframe, settings.attachto, settings.xoffset, settings.yoffset);
end

function _DUF:DUF_Set_EliteTexture()
	local texture;
  	local ELITE_SETTINGS = DUF_Settings[DUF_INDEX].target.EliteTexture
	if (ELITE_SETTINGS.elitetexture and ELITE_SETTINGS.elitetexture ~= "") then
		texture = _DUF:GetResourcePath(ELITE_SETTINGS.elitetexture)
	elseif (ELITE_SETTINGS.faceleft) then
		texture = "Interface\\AddOns\\DiscordUnitFrames\\Icons\\EliteLeft";
	else
		texture = "Interface\\AddOns\\DiscordUnitFrames\\Icons\\Elite";
	end
	if (DUF_OPTIONS_VISIBLE and (not ELITE_SETTINGS.hide)) then
		DUF_TargetFrame_EliteTexture_Texture:SetTexture(texture);
		DUF_TargetFrame_EliteTexture:Show();
		DUF_TargetFrame_EliteTexture:SetAlpha(ELITE_SETTINGS.alpha);
		return;
	end
	local classification = UnitClassification("target");
	if (classification == "elite" or classification == "worldboss") then
		if (not ELITE_SETTINGS.hide) then
			DUF_TargetFrame_EliteTexture_Texture:SetTexture(texture);
			DUF_TargetFrame_EliteTexture:SetAlpha(ELITE_SETTINGS.alpha)
		end
	elseif (classification == "rare" or classification == "rareelite") then
		if (not ELITE_SETTINGS.hide) then
			if (ELITE_SETTINGS.raretexture and ELITE_SETTINGS.raretexture ~= "") then
				texture = _DUF:GetResourcePath(ELITE_SETTINGS.raretexture)
			elseif (ELITE_SETTINGS.faceleft) then
				texture = "Interface\\AddOns\\DiscordUnitFrames\\Icons\\RareLeft";
			else
				texture = "Interface\\AddOns\\DiscordUnitFrames\\Icons\\Rare";
			end
			DUF_TargetFrame_EliteTexture_Texture:SetTexture(texture);
			DUF_TargetFrame_EliteTexture:SetAlpha(ELITE_SETTINGS.alpha)
		end
	else
		DUF_TargetFrame_EliteTexture:SetAlpha(0)
	end
end

function _DUF:DUF_Set_Portrait(unit)
	local frame = _G[DUF_FRAME_DATA[unit].frame .. "_Portrait"];
	if not frame then return end
	if (not frame:IsVisible()) then return; end
	local use3D, use3Dface = _DUF:DUF_Get3D(unit)
	if (use3D) then
--		if not frame.model then
--			frame.model = _G[DUF_FRAME_DATA[unit].frame .. "_Portrait_Model"]
--		end
		frame.Model.seqtime = 0
		frame:SetAlpha(1)
		frame.Model:SetUnit(unit)
		if (DUF_OPTIONS_VISIBLE) then
			frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = ""})
			frame:SetBackdropColor(0,0,1,0.5)
			if (not UnitExists(unit) or (UnitExists(unit) and not UnitIsVisible(unit))) then
				frame.Model:SetUnit('player')
			end
		else
			frame:SetBackdrop(nil)
			frame:SetBackdropColor(0, 0, 0 , 0)
		end
		if (use3Dface) then
			--SetCamera(1)
			frame.Model:SetPortraitZoom(1)
		else
			--frame:SetCamera(0)
			frame.Model:SetPortraitZoom(0)
		end
		frame.Model:SetPosition(0, 0, 0)
		return
	else   
		local texture = _G[DUF_FRAME_DATA[unit].frame.."_Portrait"].Portrait
		texture:SetTexCoord(0, 1, 0, 1);
		if (UnitName(unit)) then
			SetPortraitTexture(texture, unit);
		else
			SetPortraitTexture(texture, "player");
		end
		if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].Portrait.useclass and UnitIsPlayer(unit)) then
			local class, file = UnitClass(unit);
			local left, right, top, bottom = unpack(classesIcons[file])
--[[ -- Legion
			if (class == DUF_TEXT.Warrior) then
				left, right, top, bottom = .25, 0, 0, .25;
			elseif (class == DUF_TEXT.Mage) then
				left, right, top, bottom = .5, .25, 0, .25;
			elseif (class == DUF_TEXT.Rogue) then
				left, right, top, bottom = .75, .5, 0, .25;
			elseif (class == DUF_TEXT.Druid) then
				left, right, top, bottom = 1, .75, 0, .25;
			elseif (class == DUF_TEXT.Hunter) then
				left, right, top, bottom = .25, 0, .25, .5;
			elseif (class == DUF_TEXT.Shaman) then
				left, right, top, bottom = .5, .25, .25, .5;
			elseif (class == DUF_TEXT.Priest) then
				left, right, top, bottom = .75, .5, .25, .5;
			elseif (class == DUF_TEXT.Warlock) then
				left, right, top, bottom = 1, .75, .25, .5;
			elseif (class == DUF_TEXT.Paladin) then
				left, right, top, bottom = .25, 0, .5, .75;
			elseif (class == DUF_TEXT.DeathKnight) then
				left, right, top, bottom = .5, .25, .5, .75;
			elseif (class == DUF_TEXT.Monk) then
				left, right, top, bottom = .5, .75, .5, .75;
			elseif (class == DUF_TEXT.Monk) then
				left, right, top, bottom = .5, .75, .5, .75;
			end
]]--
			if (class) then
				texture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes");
				texture:SetTexCoord(right, left, top, bottom);	
			end
		end
		if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[unit].index].Portrait.flip) then
			local ULx, ULy, LLx, LLy, URx, URy, LRx, LRy = texture:GetTexCoord()
			texture:SetTexCoord(URx, ULy, LRx, LLy, ULx, URy, LLx, LRy);	
		end
	end
end

function _DUF:DUF_Set_RaceIcon(unit, toggle, texture)
	local race = UnitRace(unit);
	local sex = UnitSex(unit);
	local ctype = UnitCreatureType(unit);
	local faction = UnitFactionGroup(unit);
	if (not texture) then
		texture = _G[DUF_FRAME_DATA[unit].frame.."_RaceIcon"].Icon
	end;
	if (race == DUF_TEXT.Draenei) then --Fizzlemizz: May want to change this at some stage to something more generic rather than tagging each unit frame
		_G[DUF_FRAME_DATA[unit].frame].deathseq = 121;
	else
		_G[DUF_FRAME_DATA[unit].frame].deathseq = 1;
	end
	if (texture.targetIcon) then
		local targetIndex
		if (unit == "target" or unit == "targettarget" or unit == "focus") then
			targetIndex = GetRaidTargetIndex(unit)
		else
			targetIndex = GetRaidTargetIndex(unit.."target")
		end
--		targetIndex = GetRaidTargetIndex(unit)
		if (targetIndex) then
			SetRaidTargetIconTexture(texture, targetIndex)
			texture:Show();
		else
			texture:Hide();
		end
		return
	end
	if (toggle) then
		texture = _G[DUF_FRAME_DATA[unit].frame.."_ClassIcon"].Icon
	end
	if (not UnitName(unit)) then
		race=DUF_TEXT.Human;
		sex=1;
	end
	texture:Show();
	if (race and sex) then
		texture:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Races");
		if (sex == 2) then
			if (race == DUF_TEXT.Human)	     then texture:SetTexCoord(   0,  .125,    0,  .25)
			elseif (race == DUF_TEXT.Dwarf)      then texture:SetTexCoord(.125,  .250,    0,  .25)
			elseif (race == DUF_TEXT.NightElf)   then texture:SetTexCoord(.375,  .500,    0,  .25)
			elseif (race == DUF_TEXT.Gnome)      then texture:SetTexCoord(.250,  .375,    0,  .25)
			elseif (race == DUF_TEXT.Draenei)    then texture:SetTexCoord(.500,  .625,    0,  .25)
			elseif (race == DUF_TEXT.Orc)        then texture:SetTexCoord(.375,  .500,  .25,  .50)
			elseif (race == DUF_TEXT.Undead)     then texture:SetTexCoord(.125,  .250,  .25,  .50)
			elseif (race == DUF_TEXT.Tauren)     then texture:SetTexCoord(   0,  .125,  .25,  .50)
			elseif (race == DUF_TEXT.Troll)      then texture:SetTexCoord(.250,  .375,  .25,  .50)
			elseif (race == DUF_TEXT.BloodElf)   then texture:SetTexCoord(.500,  .625,  .25,  .50)
			elseif (race == DUF_TEXT.DeathNight) then texture:SetTexCoord(.500,  .625,  .75, 1.00) 
			elseif (race == DUF_TEXT.Worgen)     then texture:SetTexCoord(.625,  .750,   .0,  .25) 
			elseif (race == DUF_TEXT.Goblin)     then texture:SetTexCoord(.625,  .750,  .25,  .50) 
			end
		else                                                                          
			if (race == DUF_TEXT.Human)     then texture:SetTexCoord(   0,  .125,  .50,  .75)
			elseif (race == DUF_TEXT.Dwarf)     then texture:SetTexCoord(.125,  .250,  .50,  .75)
			elseif (race == DUF_TEXT.NightElf)  then texture:SetTexCoord(.375,  .500,  .50,  .75)
			elseif (race == DUF_TEXT.Gnome)     then texture:SetTexCoord(.250,  .375,  .50,  .75)
			elseif (race == DUF_TEXT.Draenei)   then texture:SetTexCoord(.500,  .625,  .50,  .75)
			elseif (race == DUF_TEXT.Orc)       then texture:SetTexCoord(.375,  .500,  .75, 1.00)
			elseif (race == DUF_TEXT.Undead)    then texture:SetTexCoord(.125,  .250,  .75, 1.00)
			elseif (race == DUF_TEXT.Tauren)    then texture:SetTexCoord(   0,  .125,  .75, 1.00)
			elseif (race == DUF_TEXT.Troll)     then texture:SetTexCoord(.250,  .375,  .75, 1.00)
			elseif (race == DUF_TEXT.BloodElf)  then texture:SetTexCoord(.500,  .625,  .75, 1.00)
			elseif (race == DUF_TEXT.DeathNight)  then texture:SetTexCoord(.500,  .625,  .75, 1.00) 
			elseif (race == DUF_TEXT.Worgen)     then texture:SetTexCoord(.625,  .759,  .50,  .75) 
			elseif (race == DUF_TEXT.Goblin)     then texture:SetTexCoord(.625,  .750,  .75,  1.00) 
			end
		end
	elseif (UnitPlayerControlled(unit)) then
		texture:SetTexCoord(0, 1, 0, 1);
		texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Sheep")
	elseif (ctype) then
		texture:SetTexCoord(0, 1, 0, 1);
		if (ctype == DUF_TEXT.Beast) then texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Beast")
		elseif (ctype == DUF_TEXT.Dragonkin) then texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Dragonkin")
		elseif (ctype == DUF_TEXT.Critter) then texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Critter")
		elseif (ctype == DUF_TEXT.Demon) then texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Demon")
		elseif (ctype == DUF_TEXT.Elemental) then texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Elemental")
		elseif (ctype == DUF_TEXT.Giant) then texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Giant")
		elseif (ctype == DUF_TEXT.Humanoid) then
			if (faction == DUF_TEXT.Horde) then
				texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Horde")
			elseif (faction == DUF_TEXT.Alliance) then
				texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Alliance")
			else
				texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Humanoid")
			end
		elseif (ctype == DUF_TEXT.NotSpecified) then texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\NotSpecified")
		elseif (ctype == DUF_TEXT.Summoned) then texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Summoned")
		elseif (ctype == DUF_TEXT.Undead) then texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Undead")
		else texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Gryphon")
		end
	else
		texture:SetTexCoord(0, 1, 0, 1);
		texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Unknown")
	end
end
